/* matthew's sprite engine */
/* compile with -lvgagl -lvga */
/* overlays sprites onto a background and displays,
   similar to Commodore 64 VIC chip */

/* $Id: kidnap.c,v 1.11 1996/07/14 12:37:35 matthew Exp $ */

#include <stdio.h>
#include <string.h>
#include <vga.h>
#include <stdlib.h>
#include <unistd.h>
#include <malloc.h>
#include <string.h>
#include <time.h>
#include <math.h>

#include "sprite.h"
#include "soundIt.h"

signed int dummy;
int dummy2; /* experimental variables */
int dummy3;

FILE *fp;

char *tmpstring;

int level, lives, score, reloadcount, enemyflipcount, deadcount, rapidfirecount, explodecount;

int sound = 0;

#define NUMSAMPLES 6
char *sample_fnames[NUMSAMPLES] =
{
	"lstart3.snd",
	"kill.snd",
	"lhit2.snd",
	"die.snd",
	"swarsexp.snd",
	"whoosh.snd"
};

Sample samples[NUMSAMPLES];

extern char *workvirtual;
extern char *backvirtual;
char *titlescreen;

extern signed int spritex[1000];
extern signed int spritey[1000];
extern int spritee[1000];
extern int spritet[1000];
int spritez[1000];
int spritez2[1000];

int main (int argc, char *argv[]);
void newgame (void);
void level_init (void);
void play (void);
void title (void);
void instruct (void);
int rnd (int z);
void endleveleffect (void);

int main (int argc, char *argv[])
{
	int i;

	srandom(time);
		
	tmpstring=malloc(100);
	titlescreen=malloc(64000);
	for (i = 0; i < NUMSAMPLES; i++)
		Snd_loadRawSample (sample_fnames[i], &samples[i]);
	if (!(sound = !Snd_init (NUMSAMPLES, samples, 22050, 3, "/dev/dsp")) < 0)
		printf ("Buy a sound card!\n");
	
	spr_init ();
	spr_loadspr ("you.spr", 0);
	spr_loadspr ("mship.spr", 1);
	spr_loadspr ("alien1.spr", 2);
	spr_loadspr ("alien2.spr", 3);
	spr_loadspr ("shot.spr", 4);
	spr_loadspr ("ashot.spr", 5);
	spr_loadspr ("brick.spr", 6);
	spr_loadspr ("aship.spr", 7);
	spr_loadspr ("shield.spr", 8);
	spr_loadspr ("shieldl.spr", 9);
	spr_loadspr ("shieldr.spr", 10);
	spr_loadspr ("motherl.spr", 11);
	spr_loadspr ("motherr.spr", 12);
	spr_loadspr ("bug.spr", 13);
	spr_loadspr ("bugdown.spr", 14);
	spr_loadspr ("spec1.spr", 15);
	spr_loadspr ("spec2.spr", 16);
	spr_loadspr ("spec3.spr", 17);
	spr_loadspr ("powerb.spr", 18);
	spr_loadspr ("powerl.spr", 19);
	spr_loadspr ("powerr.spr", 20);
	font_init();

      dotitle:
	title();
	
	newgame ();
	level_init ();
	
      playloop:
	play ();
	if (deadcount==1 && lives==0)
		{
		spr_kill(0);
		for (dummy=0;dummy<1000;dummy++)
			spr_kill(dummy);
		spr_update_reverse();
		sleep(2);
		goto dotitle;
		}
	if (numaliens()==0)
		{
		sleep(1);
		endleveleffect();
		for (dummy=0;dummy<1000;dummy++)
			spr_kill(dummy);
		spr_update_reverse();
		sleep(1);
		level++; lives++;
		level_init();
		}
	goto playloop;
}

int rnd(int m)
{
	return(random()/(RAND_MAX/m));
}

int srnd(int m)
{
	signed int n;
	n=rnd(m);
	if (rnd(2)==1) n=-n;
	return(n);
}

void title (void) /* display title screen */
{
	double d;
	float f;
	signed int i;
	int z, zz;
	char key;
	char *scrolly=malloc(3000);
	fp = fopen("kidnap-title.raw","r");
	for (dummy=0;dummy<64000;dummy++)
		{
		*(titlescreen+dummy)=fgetc(fp);
		}
	fclose(fp);
			/* colour 80 = white
			colour 111 = dark grey
			color 100 = approx 50% grey */
/*	for (f=0;f<0.3;f=f+0.001)
		{
		for (dummy=100;dummy<108;dummy++)
			{
			for (dummy2=0;dummy2<320;dummy2=dummy2+2)
				{
				i = 83*(3+(cos(f*sqrt((dummy2-128)*(dummy2-128)+(dummy-128)*(dummy-128))))+cos(dummy2/21.0)+cos(dummy/26.0));
				i = 100+(i/32);
				setpixel(dummy2, dummy, i, backvirtual);
				setpixel(dummy2+1, dummy, i, backvirtual);
				}
			}
		spr_update();
		}*/
//	for (dummy=0;dummy<320;dummy++) setpixel(dummy,199,90,titlescreen);
//	for (dummy=0;dummy<320;dummy++) setpixel(dummy,190,90,titlescreen);
	write_string(10,150,"Press space to play",90,0,titlescreen,0);
	write_string(10,160,"Press I for instructions",90,0,titlescreen,0);
	write_string(10,170,"Press Q to quit",90,0,titlescreen,0);
	sprintf(scrolly,"                                                 Welcome to Cosmic Kidnap 0.01 for Linux, an arcade-style shoot'em-up based on an old Beeb game of the same name. The object is the same as the Beeb version : blow away the aliens before they get at the ships. For more complete instructions press I. If you haven't already noticed the text above, pressing space will start the game and pressing Q will exit to the shell or wherever you started the game from. The keys in the game are : Z to move left, X to move right, space to fire. One thing not mentioned in the instructions (added afterwards): powerups. These are grey circles with red symbols on. The powerup with the radiation symbol is a smart bomb. It kills everything on the screen (except you). The powerup with the ship on gives you an extra life. The powerup with the lines on gives you rapid fire for a limited time. A bar in the top-right of the screen shows how long you have left until rapid fire runs out. To collect a powerup simply let it fall on you. Powerups are produced when you kill enemies. It is unlikely that killing a standard alien will produce one. It is more likely when you kill a mothership and most likely when you kill the BUG.                                                         Now go and play the game!                                Thanks to:     Tom Lees (a.k.a. YogMan), for helping me to write this game and making my code a bit more professional.        Linus Torvalds, for making Linux.        Brad Pitzel, for writing the soundIt library used for the sound in this game.        Superior Software, for writing the game on which this is based.                                           Antigreetz to:   Bill Gates... need I say more? (BTW check out http://www.microsnot.com)        Intel... the AMD K5 is far superior to anything you could make!                                       Alright! That's all! Play the game!                                                                     Still reading? OK, here's some useless information. The title picture above was rendered in POV-Ray 3 (Linux version of course). I crufted it together in just an hour or two, without taking much care over it. You can tell can't you? The in-game graphics were made in Neopaint 3. I wrote the sprite engine myself. It is highly inefficient and I will probably write a new one for my next game.                                                        Message ends.");
	titleloop:
	for (dummy=0;dummy<strlen(scrolly);dummy++)
		{
		snprintf(tmpstring,42,"%s",(scrolly+dummy));
		for (dummy2=0;dummy2<8;dummy2++)
			{
			memcpy(backvirtual,titlescreen,64000);
			write_string(0-dummy2,191,tmpstring,80,0,backvirtual,0);
			vga_waitretrace();
			spr_update();
			key = vga_getkey();
			if (key == 'q' || key == 'Q') exit(1);
			if (key == 'i' || key == 'I') instruct();
			if (key == ' ') goto end;
			}
		}
	key = vga_getkey();
	if (key == 'q' || key == 'Q') exit(1);
	if (key == 'i' || key == 'I') instruct();
	if (key == ' ') goto end;
	goto titleloop;
	scanf("%d",dummy);
	end:
}

void instruct (void)
{
	fp = fopen("kidnap-instructions.raw","r");
	for (dummy=0;dummy<64000;dummy++)
		{
		*(backvirtual+dummy)=fgetc(fp);
		}
	fclose(fp);
	spr_update_reverse();
	while (vga_getkey()!=' ') ;
}

void newgame (void) /* start a new game */
{
	/* kill all sprites */
	for (dummy = 0; dummy < 1000; dummy++)
		spr_kill (dummy);

	/* set up variables */
	lives = 3;
	level = 1;
	score = 0;
	reloadcount = 0;
	rapidfirecount = 0;
	enemyflipcount = 10;
	deadcount = 0;
	explodecount = 0;
	
}

void level_init (void)
{
	char a;
	for (dummy=0; dummy<64000; dummy++) *(backvirtual+dummy)=0;
	spr_add (148, 188, 0); spritee[0]=0;
	spr_add (146,41,7);
	spr_add (146,71,7);
	spr_add (146,101,7);
	sprintf(&a,"%d",level);
	write_char(8,0,a,95,0,backvirtual,0);
	write_string(32,0,"Score:          Lives:       ",80,0,backvirtual,0);
	for (dummy = 0; dummy < 12; dummy++)
		{dummy2=spr_add2 (0, dummy * 10 + 12, 2); /* draw aliens */
		spritee[dummy2]=0; spritez[dummy2]=0;}
	for (dummy = 0; dummy < 12; dummy++)
		{dummy2=spr_add2 (296, dummy * 10 + 12, 3);
		spritee[dummy2]=0; spritez[dummy2]=1;}
//	dummy2=spr_add2(0,50,2); spritee[dummy2]=0; spritez[dummy2]=0; /* draw single alien for testing */
	if (level>5)
		{
		dummy2=spr_add2(0,160,15); spritee[dummy2]=0; spritez[dummy2]=0; /* draw specs */
		dummy2=spr_add2(60,160,15); spritee[dummy2]=0; spritez[dummy2]=75;
		dummy2=spr_add2(180,160,15); spritee[dummy2]=0; spritez[dummy2]=125;
		dummy2=spr_add2(240,160,15); spritee[dummy2]=1; spritez[dummy2]=224;
		}
	for (dummy = 0; dummy < 12; dummy++) /* draw bricks */
		if (dummy!=3 && dummy!=6 && dummy!=9)
		{for (dummy2 = 100; dummy2 < 220; dummy2 = dummy2 + 6)
			spr_add (dummy2, dummy * 10 + 12, 6);}
		else
		{for (dummy2 = 100; dummy2 < 142; dummy2 = dummy2 + 6)
			spr_add (dummy2, dummy * 10 + 12, 6);
		for (dummy2 = 178; dummy2 < 220; dummy2 = dummy2 + 6)
			spr_add (dummy2, dummy * 10 + 12, 6);}
	for (dummy2 = 162; dummy2 < 178; dummy2 = dummy2 + 8) /* draw left shield */
		{for (dummy = 40; dummy < 76; dummy = dummy + 4)
		if (dummy2==162 && dummy==40)
			spr_add (dummy, dummy2, 9);
		else if (dummy2==162 && dummy==72)
			spr_add (dummy, dummy2, 10);
		else
			spr_add (dummy, dummy2, 8);}
	for (dummy2 = 162; dummy2 < 178; dummy2 = dummy2 + 8) /* draw middle shield */
		{for (dummy = 142; dummy < 178; dummy = dummy + 4)
		if (dummy2==162 && dummy==142)
			spr_add (dummy, dummy2, 9);
		else if (dummy2==162 && dummy==174)
			spr_add (dummy, dummy2, 10);
		else
			spr_add (dummy, dummy2, 8);}
	for (dummy2 = 162; dummy2 < 178; dummy2 = dummy2 + 8) /* draw right shield */
		{for (dummy = 244; dummy < 280; dummy = dummy + 4)
		if (dummy2==162 && dummy==244)
			spr_add (dummy, dummy2, 9);
		else if (dummy2==162 && dummy==276)
			spr_add (dummy, dummy2, 10);
		else
			spr_add (dummy, dummy2, 8);}
	explodecount=0;
	spr_update_reverse(); sleep(1);
}

void play (void)
{
	char key;
	int r,g,b;

	sprintf(tmpstring,"%d",score);
	write_string(88,0,tmpstring,85,0,backvirtual,1);
	sprintf(tmpstring,"%d",lives);
	write_string(216,0,tmpstring,85,0,backvirtual,1);
	
	if (deadcount==1) spritex[0]=148;
	if (deadcount!=0) deadcount--;

	if (explodecount!=0) explodecount--;
	if (explodecount!=0)
		vga_setpalette(0,explodecount*3,explodecount*3,explodecount*3);
	else 	vga_setpalette(0,0,0,0);
	
	spr_update_reverse ();
	if (reloadcount != 0)
		reloadcount--;
	if (rapidfirecount != 0)
		rapidfirecount--; 
	key = vga_getkey ();
	if ((key == 'z' || key == 'Z') && spritex[0] > 15 && deadcount==0)
		spritex[0] = spritex[0] - 4;
	if ((key == 'x' || key == 'X') && spritex[0] < 275 && deadcount==0)
		spritex[0] = spritex[0] + 4;
	if (key == 'q' || key == 'Q') {lives=0; deadcount=1;}
	if (key == ' ' && reloadcount == 0 && deadcount==0)
		{
			spr_add (spritex[0] + 14, 180, 4);
			if (rapidfirecount==0) reloadcount = 32;
			else reloadcount = 4;
			if (sound)
				Snd_effect (0, 0);
		}
	enemyflipcount--;
	if (enemyflipcount==0) enemyflipcount=10;
	if (rnd(1000)==0) spritee[spr_add2(0,2,11)]=1;
	if (rnd(1000)==0) spritee[spr_add2(288,2,11)]=2;
	if (rnd(1000)==0 && isbug()==0 && level>2) spritee[spr_add2(0,130,13)]=0;
	for (dummy = 0; dummy < 1000; dummy++)
		{
			if (spritet[dummy] == 4) /* bullet */
				{
					spritey[dummy] = spritey[dummy] - 3; /* move bullet up */
					dummy2 = spr_pix3collide (spritex[dummy],
								  spritey[dummy],
								  dummy);
					if (dummy2 != 1001 && spritet[dummy2]!=18 && spritet[dummy2]!=19 && spritet[dummy2]!=20)
						{
							spr_kill (dummy); /* if bullet hits a sprite, make a sound */
							if (sound)
								Snd_effect (2, 2);
						}
					if ((spritet[dummy2] == 2 ||
					    spritet[dummy2] == 3)) /* has bullet hit an alien? */
						{
							if (spritee[dummy2]>2) spr_kill(dummy2);
							else
							{
							spritee[dummy2]=3;
							spritet[dummy2]=2;
							score = score + 10;
							if (rnd(2)==0) spr_add(spritex[dummy2],spritey[dummy2],18);
							else if (rnd(50)==0) spr_add(spritex[dummy2],spritey[dummy2],19);
							else if (rnd(50)==0) spr_add(spritex[dummy2],spritey[dummy2],20);
							if (sound)
								Snd_effect (1, 1);
							}
						}
					if (spritet[dummy2]==5)
						{
							spr_kill(dummy);
							spr_kill(dummy2);
							score = score + 2;
						}
					if (spritet[dummy2]==8 || spritet[dummy2]==9 || spritet[dummy2]==10)
						{
							spr_kill(dummy2);
						}
					if (spritet[dummy2]==11 || spritet[dummy2]==12)
						{
							if (spritee[dummy2]<3)
								{spritee[dummy2]=3;
								spritet[dummy2]=11;
								score = score + 50;
								if (rnd(14)==0) spr_add(spritex[dummy2],spritey[dummy2],18);
								else if (rnd(7)==0) spr_add(spritex[dummy2],spritey[dummy2],19);
								else if (rnd(7)==0) spr_add(spritex[dummy2],spritey[dummy2],20);
								if (sound) Snd_effect (1,1);}
						}
					if (spritet[dummy2]==14)
						{
							if ( (spritex[dummy]>=spritex[dummy2] && spritex[dummy]<=spritex[dummy2]+6)
							|| (spritex[dummy]<=spritex[dummy2]+36 && spritex[dummy]>=spritex[dummy2]+30) )
								{spritet[dummy2]=13; spritee[dummy2]=1; score=score+100; if (sound) Snd_effect(1,1);
								if (rnd(8)==0) spr_add(spritex[dummy2],spritey[dummy2],18);
								else if (rnd(4)==0) spr_add(spritex[dummy2],spritey[dummy2],19);
								else if (rnd(4)==0) spr_add(spritex[dummy2],spritey[dummy2],20);}
						}
					if (spritet[dummy2]==15 || spritet[dummy2]==16)
						{
							spritet[dummy2]=17; spritez2[dummy2]=5;
								if (rnd(500)==0) spr_add(spritex[dummy2],spritey[dummy2],18);
								else if (rnd(250)==0) spr_add(spritex[dummy2],spritey[dummy2],19);
								else if (rnd(250)==0) spr_add(spritex[dummy2],spritey[dummy2],20);
						}
				}
			if (spritet[dummy] == 5) /* enemy bomb */
				{
					spritey[dummy] = spritey[dummy] + 2; /* move bomb down */
					if (spritey[dummy]>196) spr_kill(dummy);
					dummy2 = spr_pix3collide (spritex[dummy],
								  spritey[dummy]+5,
								  dummy);
					//if (spritet[dummy2]==2 || spritet[dummy2]==3) spr_kill(dummy); /* kill bomb if it hits another alien */
					if (spritet[dummy2]==0 && deadcount==0) /* if bomb hits your ship... */
						{
						lives--;
						rapidfirecount=0;
						spr_kill(dummy);
						deadcount=300;
						Snd_effect(3,0);
						}
					if (spritet[dummy2]==6) {spr_kill(dummy); Snd_effect(1,1);}
					if (spritet[dummy2]==15 || spritet[dummy2]==16 || spritet[dummy2]==17) {spr_kill(dummy); Snd_effect(1,1);}
					if (spritet[dummy2]==8 || spritet[dummy2]==9 || spritet[dummy2]==10) {spr_kill(dummy); spr_kill(dummy2); Snd_effect(1,1);}
				}
			if (spritet[dummy]==11 || spritet[dummy]==12) /* mother ship */
				{
					if (enemyflipcount==1 && spritee[dummy]<3)
						{
							if (spritet[dummy]==11) spritet[dummy]=12;
							else if (spritet[dummy]==12) spritet[dummy]=11;
						}
					if (spritee[dummy]==1)
						{
							spritex[dummy]=spritex[dummy]+2;
							if (spritex[dummy]>=288) spr_kill(dummy);
							if (spritet[spr_pix3collide(spritex[dummy]+32,spritey[dummy]+6,dummy)]==11 || spritet[spr_pix3collide(spritex[dummy]+32,spritey[dummy]+6,dummy)]==12)
								{if (rnd(2)==1) {spritet[dummy]=11; spritee[dummy]=3; if (sound) Snd_effect(1,1);}}
						}
					if (spritee[dummy]==2)
						{
							spritex[dummy]=spritex[dummy]-2;
							if (spritex[dummy]<=32) spr_kill(dummy);
							if (spritet[spr_pix3collide(spritex[dummy]-1,spritey[dummy]+6,dummy)]==11 && spritet[spr_pix3collide(spritex[dummy]-1,spritey[dummy]+6,dummy)]==12)
								{spritet[dummy]=11; spritee[dummy]=3; if (sound) Snd_effect(1,1);}
						}
					if (spritee[dummy]>2) spritee[dummy]++;
					if (spritee[dummy]==50) spr_kill(dummy);
				}
			if (spritet[dummy]==13) /* bug with head up */
				{
				if (spritee[dummy]==0)
					{
					if (spritex[0]>spritex[dummy]) spritex[dummy]++;
					if (spritex[0]<spritex[dummy]) spritex[dummy]--;
					if (spritex[0]-spritex[dummy]<10 && spritex[0]-spritex[dummy]>-10 && rnd(10)==0)
						spritet[dummy]=14;
					if (rnd(100)==0) spr_add(spritex[dummy]+17,spritey[dummy]+30,5);
					}
				else if (spritee[dummy]!=0)
					spritee[dummy]++;
				if (spritee[dummy]>=50)
					spr_kill(dummy);
				}
			if (spritet[dummy]==14) /* bug with head down */
				{
				if (rnd(150)==0) spritet[dummy]=13;
				if (rnd(75)==0) spr_add(spritex[dummy]+17,spritey[dummy]+30,5);
				}
			if (spritet[dummy]==15 || spritet[dummy]==16) /* specs */
				{
				if (enemyflipcount==1)
					{
					if (spritet[dummy]==15) spritet[dummy]=16;
					else if (spritet[dummy]==16) spritet[dummy]=15;
					}
				if (spritee[dummy]==0)
					{
					spritex[dummy]++;
					if (spritex[dummy]==spritez[dummy]+64) spritee[dummy]=1;
					/*if (spritet[spr_pix3collide(spritex[dummy]+32,spritey[dummy]+6,dummy)]==14
					|| spritet[spr_pix3collide(spritex[dummy]+32,spritey[dummy]+6,dummy)]==15)
						spritee[dummy]=1;*/
					}
				if (spritee[dummy]==1)
					{
					spritex[dummy]--;
					if (spritex[dummy]==spritez[dummy]) spritee[dummy]=0;
					/*if (spritet[spr_pix3collide(spritex[dummy],spritey[dummy]+6,dummy)]==14
					|| spritet[spr_pix3collide(spritex[dummy],spritey[dummy]+6,dummy)]==15)
						spritee[dummy]=0;*/
					}
				}
			if (spritet[dummy]==17)
				{
					if (spritez2[dummy]>0) spritez2[dummy]--;
					if (spritez2[dummy]==0) spritet[dummy]=15;
				}
			if (spritet[dummy]==18) /* smart bomb */
				{
					if (spritey[dummy]<188) spritey[dummy]++;
					if (spritey[dummy]==188) spr_kill(dummy);
					if (spr_pix3collide(spritex[dummy]+6,spritey[dummy]+12,dummy)==0)
						{
						explodecount=20;
						for (dummy2=0;dummy2<1000;dummy2++)
							{
							if (spritet[dummy2]==2 || spritet[dummy2]==3)
								{
								spritet[dummy2]=2;
								spritee[dummy2]=3;
								score++;								
								}
							if (spritet[dummy2]==10 || spritet[dummy2]==11)
								{
								spritet[dummy2]=11;
								spritee[dummy2]=3;
								score=score+5;
								}
							if (spritet[dummy2]==13 || spritet[dummy2]==14)
								{
								spritet[dummy2]=14;
								spritee[dummy2]=1;
								score=score+10;
								}
							if (spritet[dummy2]==15 || spritet[dummy2]==16 || spritet[dummy2]==17)
								{
								spritet[dummy2]=17;
								spritez2[dummy2]=8;
								}
							if (spritet[dummy2]==4 || spritet[dummy2]==5)
								spr_kill(dummy2);
							}
						if (sound) Snd_effect(4,1);
						spr_kill(dummy);
						}
				}
			if (spritet[dummy]==19) /* extra life */
				{
					if (spritey[dummy]<188) spritey[dummy]++;
					if (spritey[dummy]==188) spr_kill(dummy);
					if (spr_pix3collide(spritex[dummy]+6,spritey[dummy]+12,dummy)==0)
						{
						spr_kill(dummy);
						lives++;
						}
				}
			if (spritet[dummy]==20) /* rapid fire */
				{
					if (spritey[dummy]<188) spritey[dummy]++;
					if (spritey[dummy]==188) spr_kill(dummy);
					if (spr_pix3collide(spritex[dummy]+6,spritey[dummy]+12,dummy)==0)
						{
						rapidfirecount=1000;
						spr_kill(dummy);
						}
				}
			if (spritet[dummy]==2 || spritet[dummy]==3) /* other stuff for aliens */
				{if (enemyflipcount==1 && spritee[dummy]<3) /* flip aliens round */
					 {
						 if (spritet[dummy]==2) spritet[dummy]=3;
						 else if (spritet[dummy]==3) spritet[dummy]=2;
					 }
				 if (spritee[dummy]==0 && rnd(50*numaliens())==0) spritee[dummy]=1; /* small random chance that the alien will begin to move toward the bricks, the less aliens the higher the chance */
				 if (spritee[dummy]!=0 && rnd(100)==0) spr_add(spritex[dummy]+11,spritey[dummy]+9,5); /* drop a bomb */
				 if (spritee[dummy]==0 && rnd(1000)==0) spr_add(spritex[dummy]+11,spritey[dummy]+9,5);
				 if (spritee[dummy]>2) spritee[dummy]++;
				 if (spritee[dummy]==40) spr_kill(dummy);
				 /*printf("sprite %d:	x=%d	y=%d	e=%d	z=%d\n",dummy,spritex[dummy],spritey[dummy],spritee[dummy],spritez[dummy]);*/
				 if (spritez[dummy]==0) /* code for aliens on the left of the screen */
					 {
 						 if (spritee[dummy]==1) /* if alien moving 'in' */
							 {
								 /*if (spritex[dummy]==78) spritee[dummy]=2;*/
								 if (spritex[dummy]>77)
								 	{dummy2=spr_pix3collide(spritex[dummy]+24,spritey[dummy],dummy); /* collided with a brick? */
								 	if (spritet[dummy2]==6) {spr_kill(dummy2); spritee[dummy]=2;} else spritex[dummy]++; /* if so, destroy it and turn back */
								 	if (spritet[dummy2]==7) {spr_kill(dummy2); spritee[dummy]=2; 
									 				{
													lives--;
													deadcount=300;
													Snd_effect(3,0);
													} } 
									}
								 
								 if (spritex[dummy]==137) spritee[dummy]=2;	
								 else spritex[dummy]++; 
							 }
						 else if (spritee[dummy]==2) /* if alien moving 'out' */
							 {
								 if (spritex[dummy]==0) spritee[dummy]=0;
								 else spritex[dummy]--;
							 }
					 }
				 if (spritez[dummy]==1) /* code for aliens on the right of the screen */
					 {
						 if (spritee[dummy]==1) /* if alien moving 'in' */
							 {
							 /*if (spritex[dummy]==219) spritee[dummy]=2;*/
								 if (spritex[dummy]<220)
								 	{dummy2=spr_pix3collide(spritex[dummy]-1,spritey[dummy],dummy); /* collided with a brick? */
								 	if (spritet[dummy2]==6) {spr_kill(dummy2); spritee[dummy]=2;} else spritex[dummy]--; /* destroy it and turn back */
								 	if (spritet[dummy2]==7) {spr_kill(dummy2); spritee[dummy]=2;
									lives--;
			     						deadcount=300;
       									Snd_effect(3,0);
									} }
								 
								 else {spritex[dummy]--;}
								 if (spritex[dummy]==160) spritee[dummy]=2;
							 }
						 
						 else if (spritee[dummy]==2)
							 {
								 if (spritex[dummy]==296) spritee[dummy]=0;
								 else spritex[dummy]++;
							 }
					 }
				 
			 }
			if (spritey[dummy] < 0 || spritex[dummy] < 0 ||
			    (spritex[dummy] + spr_xsize(dummy)) > 319 ||
			    (spritey[dummy] + spr_ysize(dummy)) > 199)
				spr_kill (dummy); /* kill sprites that move off screen */ 
		}
}

int numaliens()
{
	int c, d; c=0;
	
	for (d=0;d<1000;d++)
		{
			if (spritet[d]==2 || spritet[d]==3) c++;
		}
	return(c);
}

int isbug()
{
	int c, d; c=0;
	
	for (d=0;d<1000;d++)
		{
			if (spritet[d]==13 || spritet[d]==14) c=1;
		}
	return(c);
}

void endleveleffect(void)
{
	Snd_effect(5,0);
	spritee[0]=1;
	for (dummy=0;dummy<300;dummy++)
		{
		spritee[0]=dummy/15;
		for (dummy2=1;dummy2<1000;dummy2++)
			{
			spritey[dummy2]=spritey[dummy2]+(dummy/15);
			if (spritey[dummy2]>190) spr_kill(dummy2);
			}
		spr_update_reverse();
		}
}
